/*
	sample_cpp.h - common definitions used in this application.
*/
#ifndef SAMPLE_CPP_H
#define SAMPLE_CPP_H

typedef struct{
	unsigned int	wanpipe_number;	
	unsigned int	interface_number;	
	unsigned char	silent;
	unsigned int	txlength;
	unsigned char	Rx_to_Tx_loopback;
	unsigned char	decode_fsk_cid;
	unsigned char	sw_dtmf;
	unsigned char	voice_codec_alaw;
	unsigned char	decode_q931;
	char			szTxFileName[MAX_PATH];
	unsigned int	txcount;
	char			no_rx_thread;
	char			stop_port;
	char			set_port_cfg;
	char			start_port;
}wp_program_settings_t;

enum DEBUG_FLAGS{
	INFO=1,
	ERR,
	DBG_IFACE,
	DBG_MAIN
};

#define DEV_NAME_LEN			100

extern void cli_out(unsigned int dbg_flag, void *pszFormat, ...);
extern unsigned int verbosity_level;

typedef struct{
	//Recieved data
	int		(*got_rx_data)(void *sang_if_ptr, void *rx_data);
	//TDM events
	void	(*got_TdmApiEvent)(void *sang_if_ptr, void *event_data);
#if USE_STELEPHONY_API
	//FSK Caller ID
	void	(*FSKCallerIDEvent)(void *sang_if_ptr, LPCTSTR Name, LPCTSTR CallerNumber, LPCTSTR CalledNumber, LPCTSTR DateTime);
	//DTMF detected in SOFTWARE
	void	(*DTMFEvent)(void *sang_if_ptr, long Key);
	//Q931 events
	void	(*Q931Event)(void *callback_context, stelephony_q931_event *pQ931Event);
#endif
}callback_functions_t;

static void DecodeLastError(LPSTR lpszFunction) 
{ 
	LPVOID lpMsgBuf;
	DWORD dwLastErr = GetLastError();
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		dwLastErr,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);
	// Display the string.
	printf("Last Error: %s (GetLastError() returned: %d)\n", lpMsgBuf, dwLastErr);
	// Free the buffer.
	LocalFree( lpMsgBuf );
} 

static char* get_time_stamp()
{
    static char formatted_time_stamp[400];
    SYSTEMTIME timestamp;
    GetLocalTime(&timestamp);
	_snprintf(formatted_time_stamp, sizeof(formatted_time_stamp), "Y:%d/M:%d/D:%d. H:%d/M:%d/S:%d/MS:%u",
		timestamp.wYear, 
		timestamp.wMonth, 
		timestamp.wDay,
		timestamp.wHour, 
		timestamp.wMinute,
		timestamp.wSecond,
		timestamp.wMilliseconds);
	return formatted_time_stamp;
}   

#define VOLATILE_CONFIG_DEMO 1

#endif//SAMPLE_CPP_H
